﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11
@EndOfDesignText@
Sub Class_Globals
	Private json As JSONParser
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
End Sub

Sub GreenPassParse( s As String ) As String

	Dim partialparse As StringBuilder
	partialparse.Initialize

	json.Initialize( s )
	
	Dim walker As Map = json.NextObject
	Dim country As String = walker.Get("1")
	Dim rec260 As Map = walker.Get("-260")
	Dim rec1 As Map = rec260.Get("1")

	Dim name As Map = rec1.Get("nam")
	partialparse.Append( "certificate issued in: " & country & "  for: " & name.Get("fn") & ", " & name.Get("gn") & " born: " & rec1.Get("dob")).Append(CRLF)

    Dim vacclist As List
	vacclist.Initialize
	Dim testlist As List
	testlist.Initialize
	Dim recoverylist As List
	recoverylist.Initialize

    
	Try
		vacclist = rec1.Get("v")  ' vaccination
		If vacclist.IsInitialized Then
		For Each rec As Map In vacclist
			Dim a As Int = rec.Get("tg")
			Dim against As String
			If a = 840539006 Then
				against = "Covid"
			Else
				against = "unknown target"
			End If
			
			Dim d As Int = rec.Get("dn")
			
			partialparse.Append( "date of vaccination: " & rec.Get("dt") & " where: " & rec.Get("co") & " dose #" & d & " against: " & against).Append(CRLF)
		Next
		End If
	Catch
		Log(LastException)
	End Try

	Try
		testlist = rec1.Get("t")
		If testlist.IsInitialized Then
			For Each rec As Map In testlist
				Dim a As Int = rec.Get("tg")
				Dim against As String
				If a = 840539006 Then
					against = "Covid"
				Else
					against = "unknown target"
				End If
			
				Dim r As Int = rec.Get("tr")
				Dim testresult As String
				If r = 260415000 Then
					testresult = "undetected"
				Else if r = 260373001 Then
					testresult = "detected..."
				Else
					testresult = "unknown"
				End If
				partialparse.Append( "date of test: " & rec.Get("sc") & " where: " & rec.Get("co") & " against: " & against & " result: " & testresult).Append(CRLF)
			Next
		End If
	Catch
		Log(LastException)
	End Try

	Try
		recoverylist = rec1.Get("r")
		
		If recoverylist.IsInitialized Then
		For Each rec As Map In recoverylist
			Dim a As Int = rec.Get("tg")
			Dim rfrom As String
			If a = 840539006 Then
				rfrom = "Covid"
			Else
				rfrom = "unknown target"
			End If
			
			partialparse.Append( "recovery from: " & rfrom & " valid until: " & rec.Get("du")).Append(CRLF)
		Next
		End If
	Catch
		Log(LastException)
	End Try

	Return(partialparse.ToString )
	
End Sub


Sub SanipassParse( s As String ) As String
	Dim matcher As Matcher
	matcher = Regex.Matcher("DC\d\d", s)
	If matcher.Find Then
		Dim pattern As String = matcher.Group(0)
	End If
	Dim startpos As Int = s.IndexOf( pattern )
	If startpos > 0 Then
		s = s.SubString( startpos )
	End If
	
	' DC01 DC02 DC03 DC04 all exist and with different
	' formats
	
	
	Dim masterregex As String
	Dim personaldata As Int
	
	If pattern.CompareTo("DC04") = 0 Then
		masterregex = "(.{2,2})(.{2,2})(.{4,4})(.{4,4})(.{4,4})(.{4,4})(.{2,2})(.{2,2})(.{2,2})(.*)"
		' find all the various "groups" in the string
		personaldata = 10
	else If pattern.CompareTo("DC03") = 0 Then
		masterregex = "(.{2,2})(.{2,2})(.{4,4})(.{4,4})(.{4,4})(.{4,4})(.{2,2})(.{2,2})(.*)"
		' group(7) type of cert
		personaldata = 9
	else If pattern.CompareTo("DC02") = 0 Or pattern.CompareTo("DC01") Then
		masterregex = "(.{2,2})(.{2,2})(.{4,4})(.{4,4})(.{4,4})(.{4,4})(.{2,2})(.*)"
		' group(7) type of cert
		personaldata = 8
	Else
		Log("unknown version: " & pattern)
	End If
	
	If masterregex.Length > 0 Then   ' we have a matching pattern
		matcher = Regex.Matcher( masterregex, s )
		If matcher.find Then
			Dim certtype As String = matcher.Group(7)
			If certtype = "B2" Then
				certtype = "test"
			else if certtype = "L1" Then
				certtype = "vaccination"
			Else
				certtype = "unknown type of certificate"
			End If
			
			Dim importantstuff = matcher.Group( personaldata )   ' will vary depending on version
			Dim personregex = "F0(.*?)%1DF1(.*?)%1DF2(.{8,8})F3(.)F4(.*?)%1DF5(.)F6(.*?)%1F"       ' ends with %1F  the rest is signature
			Dim personmatcher As Matcher
			personmatcher = Regex.Matcher(personregex, importantstuff)
			If personmatcher.Find Then
				Dim dob As String = personmatcher.Group(3)
				dob = dob.SubString2(0,2) & "-" & dob.SubString2(2,4) & "-" & dob.SubString2(4,8)
				Log(certtype & " for: " & personmatcher.Group(1) & ", " & personmatcher.Group(2) & " " & dob & " " & personmatcher.group(4) & " ")
			End If
		End If
	End If
	
End Sub

